﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace CV10Control
{
    public class Calculator : CompositeControl
    {
        TextBox in1 = new TextBox();
        DropDownList ddl = new DropDownList();
        TextBox in2 = new TextBox();

        protected override void CreateChildControls()
        {
            ddl.Items.Add("+");
            ddl.Items.Add("-");
            ddl.Items.Add("*");
            ddl.Items.Add("/");

            Controls.Add(in1);
            Controls.Add(ddl);
            Controls.Add(in2);

            base.CreateChildControls();
        }

        public int Result
        {
            get
            {
                int num1 = Convert.ToInt32(in1.Text);
                int num2 = Convert.ToInt32(in2.Text);

                switch (ddl.SelectedValue)
                {
                    case "+":
                        return num1 + num2;
                    case "-":
                        return num1 - num2;
                    case "*":
                        return num1 * num2;
                    case "/":
                        return num1 / num2;
                    default:
                        throw new InvalidOperationException("Undefined operation!");
                }
            }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            writer.WriteBeginTag("table");
            writer.WriteAttribute("border", "1");
            writer.RenderBeginTag(HtmlTextWriterTag.Tr);

            writer.RenderBeginTag(HtmlTextWriterTag.Td);
            in1.RenderControl(writer);
            writer.RenderEndTag();
            
            writer.RenderBeginTag(HtmlTextWriterTag.Td);
            ddl.RenderControl(writer);
            writer.RenderEndTag();
            
            writer.RenderBeginTag(HtmlTextWriterTag.Td);
            in2.RenderControl(writer);
            writer.RenderEndTag();

            writer.RenderEndTag();
            writer.WriteEndTag("table");
        }
    }
}
